# Couenne::exprOpp Class Reference

class opposite, More...

`#include <CouenneExprOpp.hpp>`

Inheritance diagram for Couenne::exprOpp:

List of all members.

## Public Member Functions
| exprOpp (expression *al)
| Constructors, destructor.
expression * | clone (Domain *d=NULL) const
| cloning method
unary_function | F ()
| the operator's function
void | print (std::ostream &out, bool descend) const
| Output.
CouNumber | gradientNorm (const double *x)
| return l-2 norm of gradient at given point
expression * | differentiate (int index)
| differentiation
virtual expression * | simplify ()
| simplification
int | Linearity ()
| get a measure of "how linear" the expression is (see CouenneTypes.h)
void | getBounds (expression *&, expression *&)
| Get lower and upper bound of an expression (if any).
void | getBounds (CouNumber &, CouNumber &)
| Get value of lower and upper bound of an expression (if any).
virtual void | generateCuts (expression *, OsiCuts &, const CouenneCutGenerator *, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| special version for linear constraints
virtual enum expr_type | code ()
| code for comparisons
bool | isInteger ()
| is this expression integer?
bool | impliedBound (int, CouNumber *, CouNumber *, t_chg_bounds *, enum auxSign=expression::AUX_EQ)
| implied bound processing
exprAux * | standardize (CouenneProblem *, bool addAux=true)
| standardization (to deal with complex arguments)

## Detailed Description

class opposite,

Definition at line 27 of file CouenneExprOpp.hpp.

## Constructor & Destructor Documentation

Couenne::exprOpp::exprOpp | ( | expression * | al | ) | `[inline]`

Constructors, destructor.

Definition at line 32 of file CouenneExprOpp.hpp.

Referenced by clone().

## Member Function Documentation

expression* Couenne::exprOpp::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

cloning method

Reimplemented from Couenne::expression.

Definition at line 36 of file CouenneExprOpp.hpp.

References Couenne::exprUnary::argument_, and exprOpp().

unary_function Couenne::exprOpp::F | ( |  | ) | `[inline, virtual]`

the operator's function

Reimplemented from Couenne::exprUnary.

Definition at line 40 of file CouenneExprOpp.hpp.

References Couenne::opp().

void Couenne::exprOpp::print | ( | std::ostream & | out,
|  | bool | descend |
| ) |  |  | const`[virtual]`

Output.

Reimplemented from Couenne::exprUnary.

CouNumber Couenne::exprOpp::gradientNorm | ( | const double * | x | ) | `[inline, virtual]`

return l-2 norm of gradient at given point

Reimplemented from Couenne::expression.

Definition at line 48 of file CouenneExprOpp.hpp.

References Couenne::exprUnary::argument_, and Couenne::expression::Index().

expression* Couenne::exprOpp::differentiate | ( | int | index | ) | `[virtual]`

differentiation

Reimplemented from Couenne::expression.

virtual expression* Couenne::exprOpp::simplify | ( |  | ) | `[virtual]`

simplification

Reimplemented from Couenne::exprUnary.

int Couenne::exprOpp::Linearity | ( |  | ) | `[inline, virtual]`

get a measure of "how linear" the expression is (see CouenneTypes.h)

Reimplemented from Couenne::exprUnary.

Definition at line 58 of file CouenneExprOpp.hpp.

References Couenne::exprUnary::argument_, and Linearity().

Referenced by Linearity().

void Couenne::exprOpp::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  |

Get lower and upper bound of an expression (if any).

void Couenne::exprOpp::getBounds | ( | CouNumber & | ,
|  | CouNumber & |  |
| ) |  |  | `[virtual]`

Get value of lower and upper bound of an expression (if any).

Reimplemented from Couenne::expression.

virtual void Couenne::exprOpp::generateCuts | ( | expression * | ,
|  | OsiCuts & | ,
|  | const CouenneCutGenerator * | ,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  | `[virtual]`

special version for linear constraints

virtual enum expr_type Couenne::exprOpp::code | ( |  | ) | `[inline, virtual]`

code for comparisons

Reimplemented from Couenne::exprUnary.

Definition at line 75 of file CouenneExprOpp.hpp.

References Couenne::COU_EXPROPP.

bool Couenne::exprOpp::isInteger | ( |  | ) | `[inline, virtual]`

is this expression integer?

Reimplemented from Couenne::exprUnary.

Definition at line 79 of file CouenneExprOpp.hpp.

References Couenne::exprUnary::argument_, and isInteger().

Referenced by isInteger().

bool Couenne::exprOpp::impliedBound | ( | int | ,
|  | CouNumber * | ,
|  | CouNumber * | ,
|  | t_chg_bounds * | ,
|  | enum | auxSign = `expression::AUX_EQ` |
| ) |  |  | `[virtual]`

implied bound processing

Reimplemented from Couenne::expression.

exprAux* Couenne::exprOpp::standardize | ( | CouenneProblem * | ,
|  | bool | addAux = `true` |
| ) |  |  | `[virtual]`

standardization (to deal with complex arguments)

Reimplemented from Couenne::exprUnary.

The documentation for this class was generated from the following file:

- CouenneExprOpp.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines